//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <Registry.hpp>
#include "setup.h"
#include "lang.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSetupForm *SetupForm;
//---------------------------------------------------------------------------
__fastcall TSetupForm::TSetupForm(TComponent* Owner)
        : TForm(Owner)
{
   HotkeyLabel->Caption=LangText(TE_Hotkey);
   Caption=LangText(TE_Options);
   OKButton->Caption=LangText(TE_OK);
   CancelButton->Caption=LangText(TE_Cancel);
   UninstallButton->Caption=LangText(TE_Uninstall);
   StartAsLabel->Caption=LangText(TE_StartSetting);
   StartAsCombo->Items->Add(LangText(TE_Active));
   StartAsCombo->Items->Add(LangText(TE_Inactive));
   StartAsCombo->Items->Add(LangText(TE_LastSetting));

}
//---------------------------------------------------------------------------


Classes::TShortCut __fastcall TSetupForm::GetHotKey()
{
   return GetRegInt("HotKey");
}



void __fastcall TSetupForm::FormShow(TObject *Sender)
{
   HotKey1->HotKey=GetHotKey();
   StartAsCombo->ItemIndex=GetRegInt("StartAs");
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::OKButtonClick(TObject *Sender)
{
   if ((HotKey1->HotKey!=0) || (StartAsCombo->ItemIndex!=-1))
   {
      SetRegInt("HotKey", HotKey1->HotKey);
      SetRegInt("StartAs", StartAsCombo->ItemIndex);
   }
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::CancelButtonClick(TObject *Sender)
{
ModalResult = mrCancel;
}
//---------------------------------------------------------------------------



int __fastcall GetRegInt(AnsiString name)
{

  int i=0;
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    if (Registry->KeyExists("Software")) {
       Registry->OpenKey("Software",false);
       if (Registry->KeyExists("The Hovgaard Klan")) {
         Registry->OpenKey("The Hovgaard Klan",false);
         if (Registry->KeyExists("HovText")) {
            Registry->OpenKey("HovText",false);
            if (Registry->ValueExists(name))
               i = Registry->ReadInteger(name);
         }
       }
    }
  }
  catch (...)
  {
  }
  delete Registry;
  return i;
}


void __fastcall SetRegInt(AnsiString name, int i)
{
  TRegistry *Registry = new TRegistry(KEY_WRITE);
  try
  {
    Registry->OpenKey("Software",true);
    Registry->OpenKey("The Hovgaard Klan",true);
    Registry->OpenKey("HovText",true);
    Registry->WriteInteger(name, i);
  }
  catch (...)
  {
  }
  delete Registry;
}


void __fastcall TSetupForm::UninstallButtonClick(TObject *Sender)
{
   if (Application->MessageBox(LangText(TE_UninstallConfirm).c_str(),LangText(TE_Uninstall).c_str(),MB_YESNO	)==IDYES)
      Deinstall();
}

void __fastcall TSetupForm::Deinstall()
{
  bool RemoveKlan=false;
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    if (Registry->KeyExists("Software")) {
       Registry->OpenKey("Software",false);
       if (Registry->KeyExists("The Hovgaard Klan")) {
         Registry->OpenKey("The Hovgaard Klan",false);
         if (Registry->KeyExists("HovText")) {
            Registry->DeleteKey("HovText");
         }
         RemoveKlan=!Registry->HasSubKeys();
       }
    }
  }
  catch (...)
  {
  }
  delete Registry;
  if (RemoveKlan)
  {
    Registry = new TRegistry(KEY_READ);
    try
    {
       Registry->OpenKey("Software",false);
       Registry->DeleteKey("The Hovgaard Klan");
    }
    catch (...)
    {
    }
    delete Registry;
  }
  HotKey1->HotKey=0;
  StartAsCombo->ItemIndex=-1;
}
//---------------------------------------------------------------------------
